%Main Program
close all; 
clear;
clc;
warning off MATLAB:divideByZero


% %_____________________________________________________________
% %______ Opening Data File and Re-ordering Data _______________
% 


[X,headertext] = xlsread('pT7_Data');  
[Y,headertext2] = xlsread('pTet_Data'); 


option1=input('Do you want to include the pT7 data (0=No else Yes)?');
if isempty(option1)
    option1=1;
end
if (option1 ~= 0)
    option1=1;
end

option2=input('Do you want to include the pTet data (0=No else Yes)?');
if isempty(option2)
    option2=1;
end
if (option2 ~= 0)
    option2=1;
end

if (option1==0)
    option2=1;
    disp('what the heck : i will simulate for the ptet data');
end

max_size=max(option1*size(X,1),option2*size(Y,1));

length_data=zeros(option1*(size(X,2)-1)+option2*(size(Y,2)-1),1);
if option1>0
    Legend_Figure_Data=[];
    for i=1:size(X,2)-1
        length_data(i)=length(X(:,i+1));
        Legend_Figure(i)=headertext(:,i+1);
    end
end

if option2>0
    Legend_Figure_Data2=[];
    for i=1:size(Y,2)-1
        length_data(i+option1*(size(X,2)-1))=length(Y(:,i+1));
        Legend_Figure2(i)=headertext2(:,i+1);
    end
end

Time_Data=zeros(max_size,option1*(size(X,2)-1)+option2*(size(Y,2)-1));
Data_to_Match=zeros(max(length_data),option1*(size(X,2)-1)+option2*(size(Y,2)-1));

if option1>0
    for n=1:size(X,2)-1
        for i=1:length_data(n)
            Time_Data(i,n)=X(i,1)/60;
            Data_to_Match(i,n)=X(i,n+1)/90;
        end
        for i=1+length_data(n):max_size
            Time_Data(i,n)=Time_Data(length_data(n),n);
            Data_to_Match(i,n)=Data_to_Match(length_data(n),n);
        end    
    end
end

if option2>0
    for n=1:size(Y,2)-1
        for i=1:length_data(n+option1*(size(X,2)-1))
            Time_Data(i,n+option1*(size(X,2)-1))=Y(i,1)/60;
            Data_to_Match(i,n+option1*(size(X,2)-1))=Y(i,n+1)/90;
        end
        for i=length_data(n+option1*(size(X,2)-1))+1:max_size
            Time_Data(i,n+option1*(size(X,2)-1))=Time_Data(length_data(n+option1*(size(X,2)-1)),n+option1*(size(X,2)-1));
            Data_to_Match(i,n+option1*(size(X,2)-1))=Data_to_Match(length_data(n+option1*(size(X,2)-1)),n+option1*(size(X,2)-1));
        end
    end
end

color=['g' 'b' 'm' 'c' 'r' 'g' 'b' 'm' 'c' 'r' 'g' 'b' 'm' 'c' 'r' 'g' 'b' 'm' 'c'];


% %_____________________________________________________________
% %__________ Data Display _____________________________________
if option1>0
    maxi1=0;
    for n=1:size(X,2)-1
        maxi1=max(maxi1,max(Data_to_Match(:,n)));
    end
end
if option2>0
maxi2=0;
    for n=1:option1*(size(X,2)-1)+size(Y,2)-1
        maxi2=max(maxi2,max(Data_to_Match(:,n)));
    end
end
if option1>0
    figure
    hold on
    for i=1:size(X,2)-1
        plot(Time_Data(:,i),Data_to_Match(:,i), color(i));
    end
    axis([0 max(Time_Data(:,1)) 0 1.5*maxi1]);
    xlabel('time');
    ylabel('FP ');
    title(' pT7 Data');
    legend(char(Legend_Figure)); 
    hold off
end
if option2>0
    figure
    hold on
    for i=1:size(Y,2)-1
        plot(Time_Data(:,i+option1*(size(X,2)-1)),Data_to_Match(:,i+option1*(size(X,2)-1)), color(i));
    end   
    axis([0 max(Time_Data(:,size(X,2))) 0 1.5*maxi2]);
    xlabel('time');
    ylabel('FP ');
    title(' pTet Data');
    legend(Legend_Figure2); 
    hold off
end


[t,x] = ode45('Promoter_classicmodelODE',[0 20],0); 
tt=0:0.0001:50;
shape = spline(t,x,tt);

[alpha_dilatation,beta_dilatation,min_error]=CBD_Generalised_Shape_Matching(Time_Data,Data_to_Match,length_data,tt,shape);

disp(['degradation term= ' num2str(1/alpha_dilatation)]);



if option1>0
    Legend_Figure_Data=strvcat(char(Legend_Figure), Legend_Figure_Data);
    figure
    hold on
    for i=1:size(X,2)-1
        plot(alpha_dilatation*tt,beta_dilatation(i)*shape, color(i));
    end
    for i=1:size(X,2)-1
        plot(Time_Data(:,i),Data_to_Match(:,i), 'rx');
    end  
    axis([0 max(Time_Data(:,1)) 0 1.5*maxi1]);
    xlabel('time');
    ylabel('FP ');
    title(' pT7 Data');
    legend(Legend_Figure); 
    hold off
end

if option2>0
    Legend_Figure_Data2=strvcat(char(Legend_Figure2), Legend_Figure_Data2);
    figure
    hold on
    for i=1:size(Y,2)-1
        plot(alpha_dilatation*tt,beta_dilatation(i+option1*(size(X,2)-1))*shape, color(i));
    end
     for i=1:size(Y,2)-1
        plot(Time_Data(:,i+option1*(size(X,2)-1)),Data_to_Match(:,i+option1*(size(X,2)-1)), 'rx');
    end 
    axis([0 max(Time_Data(:,1)) 0 1.5*maxi2]);
    xlabel('time');
    ylabel('FP ');
    title(' pTet Data');
    legend(Legend_Figure2); 
    hold off
end
